---
title: scroll-snap-type
slug: Web/CSS/scroll-snap-type
tags:
  - CSS
  - CSS Property
  - CSS Scroll Snap
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>scroll-snap-type</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets how strictly snap points are enforced on the scroll container in case there is one.</p>

<div>{{EmbedInteractiveExample("pages/css/scroll-snap-type.html")}}</div>

<p>Specifying any precise animations or physics used to enforce those snap points is not covered by this property but instead left up to the user agent.</p>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
scroll-snap-type: none;
scroll-snap-type: x;
scroll-snap-type: y;
scroll-snap-type: block;
scroll-snap-type: inline;
scroll-snap-type: both;

/* Optional mandatory | proximity*/
scroll-snap-type: x mandatory;
scroll-snap-type: y proximity;
scroll-snap-type: both mandatory;

/* etc */

/* Global values */
scroll-snap-type: inherit;
scroll-snap-type: initial;
scroll-snap-type: unset;
</pre>

<h2 id="Syntax">Syntax</h2>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>none</code></dt>
 <dd>When the visual {{Glossary("viewport")}} of this scroll container is scrolled, it must ignore snap points.</dd>
 <dt><code>x</code></dt>
 <dd>The scroll container snaps to snap positions in its horizontal axis only.</dd>
 <dt><code>y</code></dt>
 <dd>The scroll container snaps to snap positions in its vertical axis only.</dd>
 <dt><code>block</code></dt>
 <dd>The scroll container snaps to snap positions in its block axis only.</dd>
 <dt><code>inline</code></dt>
 <dd>The scroll container snaps to snap positions in its inline axis only.</dd>
 <dt><code>both</code></dt>
 <dd>The scroll container snaps to snap positions in both of its axes independently (potentially snapping to different elements in each axis).</dd>
 <dt><code>mandatory</code></dt>
 <dd>The visual viewport of this scroll container will rest on a snap point if it isn't currently scrolled. That means it snaps on that point when the scroll action finished, if possible. If content is added, moved, deleted or resized the scroll offset will be adjusted to maintain the resting on that snap point.</dd>
 <dt><code>proximity</code></dt>
 <dd>The visual viewport of this scroll container may come to rest on a snap point if it isn't currently scrolled considering the user agent's scroll parameters. If content is added, moved, deleted or resized the scroll offset may be adjusted to maintain the resting on that snap point.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Snapping_in_different_axes">Snapping in different axes</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="holster"&gt;
&lt;div class="container x mandatory-scroll-snapping" dir="ltr"&gt;
  &lt;div&gt;X Mand. LTR&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;

&lt;div class="container x proximity-scroll-snapping" dir="ltr"&gt;
  &lt;div&gt;X Prox. LTR&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;

&lt;div class="container y mandatory-scroll-snapping" dir="ltr"&gt;
  &lt;div&gt;Y Mand. LTR&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;

&lt;div class="container y proximity-scroll-snapping" dir="ltr"&gt;
  &lt;div&gt;Y Prox. LTR&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;

&lt;div class="container x mandatory-scroll-snapping" dir="rtl"&gt;
  &lt;div&gt;X Mand. RTL&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;

&lt;div class="container x proximity-scroll-snapping" dir="rtl"&gt;
  &lt;div&gt;X Prox. RTL&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;

&lt;div class="container y mandatory-scroll-snapping" dir="rtl"&gt;
  &lt;div&gt;Y Mand. RTL&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;

&lt;div class="container y proximity-scroll-snapping" dir="rtl"&gt;
  &lt;div&gt;Y Prox. RTL&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
  &lt;div&gt;5&lt;/div&gt;
&lt;/div&gt;
&lt;/div&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">/* setup */
html, body, .holster {
  height: 100%;
}
.holster {
  display: flex;
  align-items: center;
  justify-content: space-between;
  flex-flow: column nowrap;
  font-family: monospace;
}

.container {
  display: flex;
  overflow: auto;
  outline: 1px dashed lightgray;
  flex: none;
}

.container.x {
  width: 100%;
  height: 128px;
  flex-flow: row nowrap;
}

.container.y {
  width: 256px;
  height: 256px;
  flex-flow: column nowrap;
}
/* scroll-snap */
.x.mandatory-scroll-snapping {
  scroll-snap-type: x mandatory;
}

.y.mandatory-scroll-snapping {
  scroll-snap-type: y mandatory;
}

.x.proximity-scroll-snapping {
  scroll-snap-type: x proximity;
}

.y.proximity-scroll-snapping {
  scroll-snap-type: y proximity;
}

.container &gt; div {
  text-align: center;
  scroll-snap-align: center;
  flex: none;
}

.x.container &gt; div {
  line-height: 128px;
  font-size: 64px;
  width: 100%;
  height: 128px;
}

.y.container &gt; div {
  line-height: 256px;
  font-size: 128px;
  width: 256px;
  height: 100%;
}
/* appearance fixes */
.y.container &gt; div:first-child {
  line-height: 1.3;
  font-size: 64px;
}
/* coloration */
.container &gt; div:nth-child(even) {
  background-color: #87EA87;
}

.container &gt; div:nth-child(odd) {
  background-color: #87CCEA;
}
</pre>

<h4 id="Results">Results</h4>

<p>{{EmbedLiveSample("Snapping_in_different_axes", "100%", "1630")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Scroll Snap Points", "#propdef-scroll-snap-type", "scroll-snap-type")}}</td>
   <td>{{Spec2("CSS Scroll Snap Points")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("css.properties.scroll-snap-type")}}</p>

<h2 id="See_also">See also</h2>

<ul>
  <li><a href="/en-US/docs/Web/CSS/CSS_Scroll_Snap">CSS Scroll Snap</a></li>
  <li><a href="https://developers.google.com/web/updates/2018/07/css-scroll-snap">Well-Controlled Scrolling with CSS Scroll Snap</a></li>
</ul>
